function enum_players()
for p in players_iterate() do
  log.normal("%s#%d%s", p.name, p.id, p.is_alive and "" or " (dead)")
end
end

function count_units(pid)
local p = find.player(pid)
local uc = {}
for u in p:units_iterate() do
  uc[u.utype] = (uc[u.utype] or 0) + 1
end

for t, n in pairs(uc) do
  log.normal("%d x %s", n, t:rule_name())
end
end

function count_all_units_vet()
for p in players_iterate() do
log.normal(p.name .. ":");
local uc = {}
for u in p:units_iterate() do
  local uv = uc[u.utype]
  if not uv then
    uv = {[u.veteran] = 1}
    uc[u.utype] = uv
  else 
    uv[u.veteran] = (uv[u.veteran] or 0) + 1
  end
end

for t, n in pairs(uc) do
  log.normal("  %s:", t:rule_name())
  for v, c in pairs(n) do
    log.normal("    vet(%d) x %d", v, c)
  end -- pairs(uc[ut])
end -- pairs(uc)
end--players_iterate()
end

local wonders = {"Palace", "Second Palace", "Colossus", "Copernicus' Observatory",
"Cure For Cancer", "Eiffel Tower", "Hanging Gardens", "Hoover Dam", "J.S. Bach's Cathedral",
"King Richard's Crusade", "Lighthouse", "Magellan's Expedition", "Michelangelo's Chapel",
"Mausoleum of Mausolos", "Statue of Zeus", "Temple of Artemis", "Pyramids",
--[["Statue of Liberty",]] "Sun Tzu's War Academy", "1st Five Year Plan", "2nd Five Year Plan",
"3rd Five Year Plan", "4th Five Year Plan", "5th Five Year Plan", "Marco Polo's Embassy",
}

--for k,v in pairs(wonders) do wonders[k] = nil; wonders[v] = k end

function my_wonders(plr)
local wc = {}
for k,v in pairs(wonders) do wc[v] = "--nowhere--" end
for c in find.player(plr):cities_iterate() do
  for _, n in pairs(wonders) do
    local bt = find.building_type(n)
    if bt then
    if c:has_building(bt) then
      wc[n] = c.name
    end
    else
    log.error("No building %s in the game!", n)
    wonders[n] = nil
    end
  end
end
for w, c in pairs(wc) do
  log.normal("%s in %s", w, c)
end
end

function tech_to_trade()
  for p in players_iterate() do
    if client.player:dipl_rel(p, "Has Embassy") then
      local i,t = 1,find.tech_type(1)
      while t do
        if p:knows_tech(t) and not client_player():knows_tech(t)
        then log.normal("%s knows %s", p.name, t:rule_name())
        elseif client.player():knows_tech(t) and not p:knows_tech(t)
        then log.normal("%s doesn't know %s", p.name, t:rule_name())
        end
        i=i+1
        t=find.tech_type(i)
      end
    end
  end
end

function locate_building(plr)

for c in find.player("Alfred"):cities_iterate() do
  if c:has_building(find.building_type("Palace")) then
    log.normal(c.name);client.center(c.tile)
  end
end
end

function units_supported()
for c in client.player():cities_iterate() do
 log.normal("%s:",c.name);local un={};
 for u in c:supported_iterate() do
  un[u.utype]=(un[u.utype]or 0)+1
 end
 for t, n in pairs(un) do
  log.normal(" %d x %s",n,t:rule_name())
 end
end
end

function cities_with(btn)
local b = ("Building_Type"==tolua.type(btn)) and btn or find.building_type(btn)
for c in client.player():cities_iterate() do
 if c:has_building(b) then log.normal(c.name) end
end
end

function team_territory()
local q,z={name="?"},{name="n/a"}
local c={[q]=0,[z]=0}
for p in players_iterate() do c[p]=0 end
for t in whole_map_iterate() do
  if t.terrain then
    c[t:owner() or z] = c[t:owner() or z]+1
  else c[q]=c[q]+1 end
end
local ours,theirs=c[client.player()],0 --FIXIT: self dipl rel is not team
for p,v in pairs(c) do
  log.normal("%-12s\t%d (%d%%)",p.name,v,v/(164*1.64))
  if tolua.type(p)=="Player" then
    if p:dipl_rel(client.player(),"Team") then
      ours=ours+v
    elseif p ~= client.player() then
      theirs=theirs+v
    end
  end
end
log.normal("Ours %d tiles, theirs %d (known) tiles", ours,theirs)
end

function center_enemy_move(u,tf,tt)
local p=u.owner
chat.base(("%s's %s moved from %d,%d to %d,%d"
           ):format(p.name, u.utype:rule_name(), tf.x,tf.y,tt:coords()))
if not p:dipl_rel(client.player(),"Team") then
  client.center(tt)
end end
signal.connect("unit_moved","center_enemy_move")

function forces_seen(plr)
for u in ("Player"==tolua.type(plr) and plr or find.player(plr)):units_iterate() do log.normal("%s#%d%s [%d] (%d,%d)",u.utype:rule_name(), u.id, u.veteran==0 and "" or (" v%d"):format(u.veteran), u.hp, u.tile:coords()) end
end
